#include "parser.h"

using namespace std;

int main(int argc, char **argv){
	
	if (argc != 4){
		cerr << "Usage: " << argv[0] << " [inputFile] [infoFile] [numTuples]" << endl;
		exit(0);
	}
	
	ifstream finfo(argv[2]);
	
	int numTuples, numAttributes, educationAttrOrder;
	
	numTuples = atoi(argv[3]);
	finfo >> numAttributes;
	finfo >> educationAttrOrder;
	
	int totalLength = 0;
	int *attrLength = new int[numAttributes];
	for (int i=0; i<numAttributes; i++){
		finfo >> attrLength[i];
		totalLength += attrLength[i]; 
	}
	
	int numDims = 0;
	map<int,int> activeDims;
	for (int i=0; i<numAttributes; i++){
		int dim;
		finfo >> dim;
		activeDims.insert(make_pair(dim,i));
		if (dim >= 0){
			numDims++;
		}
	}
	
	
	
	ifstream fin(argv[1]);
	
	ofstream fout;
	ostringstream filename;
	filename << "ipums_d" << numDims << "_t" << numTuples;
	fout.open(filename.str().c_str(), ofstream::out);
	
	fout << numDims;
	
	long *values = new long[numAttributes];
	
	for (int i=0; i<numTuples; i++){
		string data;
		fin >> data;
		int offset = 0;
		bool skip = false;
		
		for (int j=0; j<numAttributes; j++){
			string cur = data.substr(offset, attrLength[j]);
			long val = atoi(cur.c_str());
			if (val<0){
				val = -val;
			}
			if (j == educationAttrOrder){
				long rval = 0;
				switch (val){
				case 0:
					rval = 0;
					break;
				case 1:
					rval = 0;
					break;
				case 2:
					rval = 4;
					break;
				case 3:
					rval = 8;
					break;
				case 4:
					rval = 9;
					break;
				case 5:
					rval = 10;
					break;
				case 6:
					rval = 11;
					break;
				case 7:
					rval = 12;
					break;
				case 8:
					rval = 15;
					break;
				case 9:
					rval = 17;
					break;
				}
				values[j] = rval;
			}
			else{
				values[j] = val;
				if (val>999999){
					val = 100000;
//					skip = true;
//					break; // skip line!
				}
			}
			
			offset += attrLength[j];
		}
		
		if (!skip){
			map<int, int>::iterator iter;
			fout << endl;
			for (iter=activeDims.begin(); iter!=activeDims.end(); iter++){
				if (iter->first >= 0){
					fout << values[ iter->second ] << " ";
//					fout << values[ 2 ] << " ";
				}
			}
		}
		
	}
	
	fin.close();
	fout.close();
	

}
