#include "sampler.h"

using namespace std;

int main(int argc, char **argv){
	
	if (argc != 4){
		cerr << "Usage: " << argv[0] << " [inputFile] [inputFileSize] [outputFileSize]" << endl;
		exit(0);
	}
	
	int inSize = atoi(argv[2]);
	int outSize = atoi(argv[3]);
	
	ifstream fin(argv[1]);
	
	int numDims;
	fin >> numDims;
		
	ofstream fout;
	ostringstream filename;
	filename << argv[1] << "_S" << outSize;
	fout.open(filename.str().c_str(), ofstream::out);
	
	fout << numDims << endl;
	

	double prob = ((double) 1.01*outSize)/inSize;
	
	cout << "prob=" << prob << endl;
	
	int outCount = 0;
	
	srand48(259); // random seed
	
	for (int i=0; i<inSize; i++){
		string data;
		getline(fin, data);
		
		double rnd = drand48();
	
		if (rnd<prob){
			fout << data << endl;
			outCount++;
		}
		if (outCount==outSize) break;
	
	}
	
	fin.close();
	fout.close();
	
}