#ifndef HILKANOMPD_
#define HILKANOMPD_

#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <cfloat>

#include "../common/point.h"
#include "../common/group.h"
#include "../kdtree/kdtree.h"

using namespace std;

class HilKAnomPD{
public:
	KDTreePtr kdtree; // used to discover points for overlapping areas
	int numDimensions; // dimensionality
	vector<point> points;
	vector<group> groups; // K-anonymized groups
	int K; // anonymity requirement
	float* sizeWorld;
	
	HilKAnomPD(char* microTable, char* publicData);
	~HilKAnomPD();
	
	float* getSizeWorld();
	
	vector<group> getGroups(int K);
	
private:
	bool groupsCalculated;
};


#endif /*HILKANOMPD_*/
