#include "minpertree/minpertree.h"


using namespace std;

int main(int argc, char** argv){
	
	if (argc!=3) {
		cout << "Usage: " << argv[0] << " [microdata] [K]" << endl;
		cout << "K is anonymity requirement" << endl;
		exit(-1);
    }
	int K = atoi(argv[2]);
	int numDimensions;
	vector<pointPtr> points = readFromFile(argv[1], true, numDimensions);
	Timing* tim = new Timing();
	
	
	tim->startClock();
	MinPerTreePtr tree = new MinPerTree(points, K);
	long elapsed = tim->stopClock();
	
//	MinPerTreePtr tree = new MinPerTree(argv[1], K);
	
	
	cout << "MinPerimeter" << endl;
//	tree->printMetrics();
	
	vector<group> groups = tree->getGroups();
	
//	for (uint i=0; i<groups.size(); i++){
//		cout << &(groups[i]) << endl;
//	}
//	cout << endl;
	
//	cout << "I see " << groups.size() << " groups" << endl;
	calculateMetrics(groups, tree->sizeWorld);
	cout << "Elapsed Time: " << elapsed << endl;
	cout << "------------------------------------" << endl;
	cout << endl;
}
