#include "minpertree/minpertree.h"


using namespace std;

int main(int argc, char** argv){
	
	if (argc!=4) {
		cout << "Usage: " << argv[0] << " [microData] [publicData] [K]" << endl;
		cout << "K is anonymity requirement" << endl;
		exit(-1);
    }
	int K = atoi(argv[3]);
	int numDimensions;
	vector<pointPtr> points = readFromFile(argv[1], true, numDimensions);
	Timing* tim = new Timing();
	
    
	cout << "MinPerREF" << endl;
	tim->startClock();
	MinPerTreePtr mdTree = new MinPerTree(points, K);
	long elapsed = tim->stopClock();
	
//	MinPerTreePtr mdTree = new MinPerTree(argv[1], K);
//	MinPerTreePtr pub = new MinPerTree(argv[2], K);
	
	KDTreePtr pub = new KDTree(argv[2], 2);
	cerr << "-------------------- trees built --------------------" << endl;
	
//	cout << "before boosting " << mdTree;
//	mdTree->printMetrics();
//	
//	cout << endl;
//	vector<group> groups = mdTree->getGroups();
//	float* sizeWorld = mdTree->getSizeWorld();
//	calculateMetrics(groups, sizeWorld);
//	delete[] sizeWorld;
//	groups.clear();
//	cout << endl;
	
	
//	cout << "boosting ..." << endl;
//	mdTree->boostWithPublicData(pub);
	
	tim->startClock();
	mdTree->boostWithPublicData(mdTree->root, pub);
	elapsed += tim->stopClock();
	
//	cout << "... done boosting" << endl;
	
//	cout << "after boosting " << mdTree;
//	mdTree->printMetrics();
	
	vector<group> groups = mdTree->getGroups();
	calculateMetrics(groups, mdTree->sizeWorld);
	groups.clear();
	cout << "Elapsed Time: " << elapsed << endl;
	cout << "------------------------------------" << endl;
	cout << endl;

}
