#include "stripes/stripes.h"

#include <fstream>

using namespace std;

int main(int argc, char** argv){
	
	if (argc!=3) {
		cout << "Usage: " << argv[0] << " [microdata] [K]" << endl;
		cout << "K is anonymity requirement" << endl;
		exit(-1);
    }
	int K = atoi(argv[2]);
	int numDimensions;
	vector<pointPtr> points = readFromFile(argv[1], true, numDimensions);
	Timing* tim = new Timing();

	tim->startClock();
	Stripes* str = new Stripes(points, K);
	long elapsed = tim->stopClock();
	
//	Stripes* str = new Stripes(argv[1], K);
	
	vector<group> groups = str->getGroups();
	
	cout << "Stripes" << endl;
	calculateMetrics(groups, str->sizeWorld);
	cout << "Elapsed Time: " << elapsed << endl;
	cout << "------------------------------------" << endl;
	cout << endl;
	
	
}
