#ifndef STRIPENODE_H_
#define STRIPENODE_H_

#include <cfloat>

#include "../common/group.h"
#include "../common/point.h"



using namespace std;

typedef class stripeNode* stripeNodePtr; 



class stripeNode{
private:
	
public:
//	static int next_id;
//	int id;
	bool leafNode;
	vector<int> remainingDims; // dims for which no cut has yet performed
	int splitDim; // dimension along which cuts are performed
	vector<stripeNodePtr> children; // children nodes
	stripeNodePtr parent; // parent node
	vector<pointPtr> points; // the points inside this node;
	int numMicroPoints; // number of points from microdata
	float **extent; // the extent in low-high pairs
	float **mbr; // the mbr of the points in low-high pairs
	
	
	
	
	stripeNode(vector<int> remainingDims,  vector<pointPtr> points); // constructor
	~stripeNode();
	
	int calculateNumMicroPoints();
	
	int pickDimension(int q); // choose best dimension to split
	
	bool splitNode(int q, int K, int numDimensions, float* sizeWorld); // split and create children
	bool finalSplitNode(int q, int K, int numDimensions, float* sizeWorld);
	
	float getNCPFast(float** extent, float* sizeWorld, int numDimensions, int numMicroInCluster);
	
};
//int stripeNode::next_id = 0;


#endif /*STRIPENODE_H_*/
